﻿'HueControl.vb
'by B. Bakels
'19 Jan 2013 - version 2.0
'
'USAGE with HomeSeer
'Make an event and select script.
'create a mode device in homeseer with 4 modes wth values 
'0=dim 100=hue 200=sat 300=ct 
'For the parameter field use ("Main","Control;B80;B90;1")
'
'where: ("Main","<executionmode (Control or Status)>;<DeviceCode Homeseer Control Device>;<DeviceCode mode Device>;<Hue Number to control> ")
'Main with a capital M
'there are 2 execution modes; 	COntrol: controls the Hue lamp
'				Status: Updates the homeseer device status with the current hue status



sub Main(byVal params As Object)


'Declare params
'=============================
Dim HASH As String
Dim IP As String
Dim ACTION
Dim MODE
Dim status
DIM BRI As Integer
DIM SAT As Integer
DIM HUE As Integer
DIM COLTEMP As Integer
DIM Debug as boolean
DIM StateResponse


'setup specific settings
'=============================
Debug = true
IP = "IP"
HASH="HASH"


'read script execution additional parameters
'=============================

Dim strExecution As String = hs.StringItem(Params, 1, ";") 
Dim strDeviceControl As String = hs.StringItem(Params, 2, ";") 
Dim strDeviceMode As String = hs.StringItem(Params, 3, ";")
Dim BULBNO As string = hs.StringItem(Params, 4, ";")


'Calculate Values and get devicestatus and value
'=============================

MODE = hs.DeviceValue(strDeviceMode)
ACTION = hs.DeviceStatus(strDeviceControl)
BRI = hs.DeviceValue(strDeviceControl)*2.54
SAT = hs.DeviceValue(strDeviceControl)*2.54
HUE = hs.DeviceValue(strDeviceControl)*655.35
COLTEMP = (hs.DeviceValue(strDeviceControl)*3.46)+154

'debug mode
'=============================

If Debug = true Then 

	hs.writelog("Huecontrol Debug","Device to Control :" & strDeviceControl)
	hs.writelog("Huecontrol Debug","Device for Mode :" & strDeviceMode )
	hs.writelog("Huecontrol Debug","Hue Number :" & BULBNO )
	hs.writelog("Huecontrol Debug","Action :" & ACTION )
	hs.writelog("Huecontrol Debug","Execution mode :" & strExecution )
	hs.writelog("Huecontrol Debug","Selected Mode :" & MODE )
	hs.writelog("Huecontrol Debug","calculated Brightness :" & BRI )
	hs.writelog("huecontrol Debug","calculated Saturation :" & SAT )
	hs.writelog("huecontrol Debug","calculated Hue :" & HUE )
	hs.writelog("huecontrol Debug","calculated color temperature :" & COLTEMP )
end if

Select case strExecution

'==================================================
'==	Execution Mode; Control HUE Lamp	===
'==================================================

Case "Control"

Select case ACTION

'Hue changed to ON
'=============================
case 2
  
  status = SetHueState(BULBNO, IP, HASH, "{""on"":true}", Debug )
  hs.writelog("HueControl" , status)

'Hue changed to Off
'=============================
 case 3

  status = SetHueState(BULBNO, IP, HASH, "{""on"":false}", Debug )
  hs.writelog("HueControl" , status)

'Hue change Dim value
'=============================
 case 4
  
	Select case MODE

	'DIMMER Mode
	case 0
		status = SetHueState(BULBNO, IP, HASH, "{""on"":true,""bri"":" & BRI & "}", Debug )
 		hs.writelog("HueControl" , status)
		 
 	
	'Saturation Mode
	case 100
  		status = SetHueState(BULBNO, IP, HASH, "{""on"":true,""sat"":" & SAT & "}", Debug )
 		hs.writelog("HueControl" , status)
	
	'Hue Mode	
	case 200
  		status = SetHueState(BULBNO, IP, HASH, "{""on"":true,""hue"":" & HUE & "}", Debug )
 		hs.writelog("HueControl" , status)
	
	'Color Temperature Mode	
	case 300
  		status = SetHueState(BULBNO, IP, HASH, "{""on"":true,""ct"":" & COLTEMP & "}", Debug )
 		hs.writelog("HueControl" , status)	
	End Select

'every other case
'=============================

 case else
  status = SetHueState(BULBNO, IP, HASH, "{""on"":false}", Debug )
  hs.writelog("HueControl" , status)
 
    End Select

'==================================================
'==Execution Mode; Status update homeseer device===
'==================================================

case "Status"

	StateResponse= GetHueStatus(BULBNO, IP, HASH, Debug )
	hs.writelog("HueControl", Stateresponse)

End Select



'End of Main

End Sub









'===========================================
'==              Functions                ==
'===========================================



'GET HUE STATUS
'===========================================

Function GetHueStatus (BULBNO, IP, HASH, Debug)
 
Dim Stateresponse

	Stateresponse = hs.URLAction("http://" & IP & "/api/" & HASH &"/lights/" & BULBNO & "/","GET", "", "")
  
If Debug = true Then hs.writelog("HueControl Debug get action", Stateresponse)

return Stateresponse

End Function


'SET HUE STATE
'===========================================


Function SetHueState (BULBNO, IP, HASH, setdata, Debug)
 
Dim Setresponse
dim httpres 'http response
dim objHTTP



 ' Start the HTTP communication
   objHTTP = CreateObject ("WinHttp.WinHttpRequest.5.1" )
   objHTTP.Open("PUT", "http://" & IP & "/api/" & HASH & "/lights/" & BULBNO & "/state" , False) 
   objHTTP.Send(setdata)
   Setresponse = objHTTP.ResponseText

 ' Check if all communication went well

   httpres = objHTTP.Status
   If httpres <> 200 Then
      Hs.writelog("hueset" , "HueControl Debug set action returns error " & httpres)
   End if 

 ' And close down
   objHTTP = Nothing

If Debug = true Then hs.WriteLog("send", setdata)
If Debug = true Then hs.WriteLog("response", Setresponse)
  
  return Setresponse

End Function


'HUE ALARM STATE
'===========================================


Function SetHueAlarmState (BULBNO, IP, HASH, setdata, Debug)
 
Dim status

status = SetHueState(BULBNO, IP, HASH, "{""on"":true,""alarm"":lselect}", Debug )
hs.writelog("HueControl alarm" , status)

End Function